<id>
RollLog YaBB 2.5.2
</id>

<version>
0.6
</version>

<mod info>
Instructions:

Apply the mod and upload (in ASCII mode):

Admin/ModList.pl
Sources/SubList.pl
Sources/Subs.pl
Template/default/default.html 

From the Zip file, upload (In ASCII mode):

Languages/English/RollLog.lng
Sources/RollLog.pl
Variables/dicelog.txt

Special Instructions:

After installation, it is imperative that you log one roll to put something in the dicelog.txt file otherwise it will hang up the process when you attempt to view the dice log.
 1) Go to the Dice Roller form.
 2) Put a checkmark in the Log box.
 3) click on the "Roll Dice" button.

If you use more templates than just the default.html, you will want to copy the html code manually to those other templates or modify this .mod file. This mod file will not do that for you.  Only the default.html is modified.

General Features:

- Virtual rolling of 1 to 20 various polyhedron dice using 
  JavaScript.
- Add or subtract a modifying value.
- Add a text reason which is displayed on the dice log.
- Allow to repeat a number of times.
- Option to drop the lowest die of the number of dice rolled.
- Error checking to help prevent user-caused errors from 
  improper form use.
- Show the results without forcing a reload of the whole page 
  (if not logged) allows quick rolling.
- Verification of registered users to prevent unauthorized use 
  of bandwidth by logging spam messages.
- Display the last 30 days of logged rolls.
- Automatically trims the variables file so no manual 
  maintenance is required.
- Displays the newest rolls at the top of the list.
- Dice-rolling form is added to your template so it handily 
  shows up on every page visited (excluding the Admin center).

Revision Information:
Version 0.2 - Simplified by getting rid of the tab interface
Version 0.2 - First attempt - uses the tab.
Version 0.3 through 0.5 - various changes ditching the tab idea and going back to using the HTML form for the execution.
Version 0.6 - Ready for Beta testing.

</mod info>

<author>
ImpInTraining
</author>

<homepage>
http://darkandmoodyforums.com
</homepage>

<edit file>
Admin\ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$rolllog = "Roll Log Mod for YaBB 2.5.2|ImpInTraining|Roll 1 to 20 virtual polyhedron dice and log the results|0.6|2013-03-24";
	push (@installed_mods, "$rollog");
</add before>

<edit file>
Sources\SubList.pl
</edit file>

<search for>
'logout',"LogInOut.pl&Logout",
</search for>

<add after>
'logroll',"RollLog.pl&LogRoll",
'logrolldisplay',"RollLog.pl&RollLogDisplay",
</add after>

<edit file>
Sources\Subs.pl
</edit file>

<search for>
	$yydefaultimages = $defaultimagesdir; 
</search for>

<add after>
	$yyforumurl = $scripturl; 
</add after>


<edit file>
Templates\default\default.html
</edit file>

<search for>
</head>
</search for>

<add before>
<script language="JavaScript" type="text/javascript">
  <!-- BEGIN Dice Roller script - Added with RollLog mod.
    var die = 20;
    var dice = 1;
    var mod = 0;
    var loop = 0;
    var dicerolled = null;

    function dice_roll(sides, dice, mod, repeat) {
      if (repeat > 0 && document.rollform.rolllog.checked == false) {
        window.alert("Repeating rolls only works with the Dice Log function.");
      }
      if (repeat > 10) {
        window.alert("You can only repeat a maximum of 10 times.");
      } else if (dice >20 || dice <1) {
        window.alert("Please enter 1 to 20 dice.");
      } else if (dice == 1 && document.rollform.droplow.checked == true) {
        window.alert("If you wish to 'drop lowest', you need to roll more than one die.");
      } else {
        var roll = new Array(dice);
        var rolltot = 0;
        for (loop=0; loop < dice; loop++) {
          if (sides == "SEG") {
            roll[loop] = Math.floor(Math.random()*6);
          } else {
            roll[loop] = Math.floor(Math.random() * sides) + 1;
          }
          if (loop == 0) {
            dicerolled = roll[loop];
            var lowdie = roll[loop];
          } else {
            dicerolled = dicerolled + " " + roll[loop];
            if (roll[loop] < lowdie) {
              lowdie = roll[loop];
            }
          }
          rolltot = parseInt(rolltot) + parseInt(roll[loop]) 
        }
        rolltot = (parseInt(rolltot) + parseInt(mod));
        if (document.rollform.droplow.checked == true) {
          rolltot = (parseInt(rolltot) - parseInt(lowdie));
          dice -= 1;
          document.rollform.textdroplow.value = "drop";           
        } else {
          document.rollform.textdroplow.value = "keep";
        }
        document.rollform.textdice.value = dice;
        document.rollform.textdie.value = sides;
        document.rollform.textmod.value = mod;
        if (document.rollform.rolllog.checked == false){
          document.rollform.textrolltot.value = rolltot;
          document.rollform.textdicerolled.value = dicerolled;
        }
        if (document.rollform.rolllog.checked == true){
          document.rollform.textdateroll.value = Date();
          document.rollform.submit();
        }
      }
    }
  // END Dice Roller Script-->
</script>
</add before>

<search for>
<div class="copyright" style="width: 100%; text-align: center;">

<br />
{yabb copyright}<br />{yabb freespace}<br />
<a href="http://validator.w3.org/feed/" target="_blank"><img src="{yabb images}/valid-rss.png" alt="Valid RSS" title="Valid RSS" height="18" border="0" /></a>
<a href="http://validator.w3.org/check/referer" target="_blank"><img src="{yabb images}/xhtml.gif" alt="Valid XHTML" title="Valid XHTML" border="0" /></a>
<a href="http://jigsaw.w3.org/css-validator/" target="_blank"><img src="{yabb images}/css.gif" alt="Valid CSS" title="Valid CSS" border="0" /></a>
<a href="http://www.perl.com" target="_blank"><img src="{yabb images}/perl.gif" alt="Powered by Perl" title="Powered by Perl" border="0" /></a>
<a href="http://www.sf.net/projects/yabb" target="_blank"><img src="{yabb images}/sf.gif" alt="Source Forge" title="Source Forge" border="0" /></a><br />
{yabb debug}
<br /><br />
</div>
</search for>

<replace>
<div class="copyright" style="text-align: center;">
  <table style="padding: 5">
    <tr>
      <td bgcolor="000000">
        <form name="rollform" id="rollform" method="post" 
          action="{yabb forumurl}?action=logroll">
          <fieldset>
            <legend style="color: #ff0000; font-family: verdana; font-size: 14pt;">Dice Roller</legend>
            <table style="padding: 5; color: white">
              <tr>
                <td style="text-align: center; border: gray 1px solid">
                  What dice type?
                </td>
                <td style="text-align: center; border: gray 1px solid">
                  How many dice to roll?
                </td>
                <td style="text-align: center; border: gray 1px solid">
                  Modifier
                </td>
              </tr>
              <tr>
                <td style="vertical-align: top; text-align: middle; border: gray 1px solid">
                  <select name="sides" id="sides">
                    <option value="3">3 sided</option>
                    <option value="4">4 sided</option>
                    <option value="5">5 sided</option>
                    <option value="SEG">6 sided -1</option>
                    <option value="6">6 sided</option>
                    <option value="8">8 sided</option>
                    <option value="10">10 sided</option>
                    <option value="12">12 sided</option>
                    <option selected="selected" value="20">20 sided</option>
                    <option value="30">30 sided</option>
                    <option value="100">100 sided</option>
                  </select>
                </td>
                <td style="vertical-align: top; text-align: center; border: gray 1px solid">
                  <label for="dice">(20 or less)</label>
                  <input type="text" name="dice" id="dice" size="5" value="1" title="How many dice to roll?" />
                </td>
                <td style="vertical-align: top; text-align: center; border: gray 1px solid">
                  <input type="text" name="mod" id="mod" size="10" value="0" title="Add or subtract from the total?" />
                </td>
              </tr>
              <tr>
                <td style="text-align: center; border: gray 1px solid" colspan="2">
                  <label for="textreason">Reason</label>
                  <input type="text" size="35" name="textreason" id="textreason" title="Identify the purpose for the roll." />
                </td>
                <td style="text-align: center; border: gray 1px solid">
                  <label for="rolllog">Log?</label>
                  <input type="checkbox" name="rolllog" id="rolllog" value="Log" title="Writes results to a dice roll file for proof." />
                  <input type="hidden" name="textdateroll" id="textdateroll" />
                  <input type="hidden" name="textdroplow" id="textdroplow" />
                </td>
              </tr>
              <tr>
                <td style="border: gray 1px solid">
                  <label for="repeat">Repeat</label>
                  <input type="text" name="repeat" id="repeat" size="1" value="0" title="Make this roll more than one time?" /> x
                </td>
                <td style="text-align: center; border: gray 1px solid">
                  <label for="droplow">Drop Lowest</label>
                  <input type="checkbox" name="droplow" id="droplow" value="yes" title="Will drop the lowest of the die rolls in each sequence." />
                </td>
                <td style="border: gray 1px solid">
                  <input type="button" value="Roll Dice" name="RollDice" id="RollDice" onclick="dice_roll(sides.value, dice.value, mod.value, repeat.value);" />
                </td>
              </tr>
              <tr>
                <td style="text-align: center; border: gray 1px solid" colspan="3">
                  <label for="textdicerolled">Dice Rolled</label>
                  <input type="text" size="35" name="textdicerolled" id="textdicerolled" title="Shows each individual die roll in the sequence." />
                </td>
              </tr>
              <tr>
                <td style="text-align: center; border: gray 1px solid" colspan="3">
                  <label for="textdice">Dice Results</label>
                  <input type="text" size="5" name="textdice" id="textdice" title="How many dice rolled." />d
                  <input type="text" size="5" name="textdie" id="textdie" title="How many sides on each die." /> +
                  <input type="text" size="5" name="textmod" id="textmod" title="Modifier to the roll total." /> = 
                  <input type="text" size="5" name="textrolltot" id="textrolltot" title="End Result" /> 
                </td>
              </tr>
            </table>
          </fieldset>
        </form>
        <a href="{yabb forumurl}?action=logrolldisplay" target="dicelog">See the Dice Log</a>
      </td>
      <td>
		{yabb copyright}<br />{yabb freespace}<br />
		<a href="http://validator.w3.org/feed/" target="_blank"><img src="{yabb images}/valid-rss.png" alt="Valid RSS" title="Valid RSS" height="18" border="0" /></a>
		<a href="http://validator.w3.org/check/referer" target="_blank"><img src="{yabb images}/xhtml.gif" alt="Valid XHTML" title="Valid XHTML" border="0" /></a>
		<a href="http://jigsaw.w3.org/css-validator/" target="_blank"><img src="{yabb images}/css.gif" alt="Valid CSS" title="Valid CSS" border="0" /></a>
		<a href="http://www.perl.com" target="_blank"><img src="{yabb images}/perl.gif" alt="Powered by Perl" title="Powered by Perl" border="0" /></a>
		<a href="http://www.sf.net/projects/yabb" target="_blank"><img src="{yabb images}/sf.gif" alt="Source Forge" title="Source Forge" border="0" /></a><br />
		{yabb debug} <br /><br />      
	</td>
    </tr>
  </table>
  <br />
  <br />
</div>
</replace>
